%define name            httpunit
%define version         1.5.2
%define release         1jpp
%define javadir         %{_datadir}/java
%define javadocdir      %{_datadir}/javadoc
%define section         free

Name:           %{name}
Version:        %{version}
Release:        %{release}
Summary:        Automated web site testing toolkit
License:        MIT
Source0:        http://download.sourceforge.net/httpunit/httpunit-1.5.2.zip
Patch0:         httpunit.build.patch
URL:            http://httpunit.sourceforge.net/
BuildRequires:  ant
BuildRequires:  nekohtml
BuildRequires:  jtidy
BuildRequires:  junit >= 3.8
BuildRequires:  servlet
BuildRequires:  javamail >= 1.2
BuildRequires:  jaf >= 1.0.1
BuildRequires:  rhino
BuildRequires:  perl
Requires:       junit >= 3.8
Requires:       servlet
Requires:       jaxp_parser_impl
# As of 1.5, requires either nekohtml or jtidy, and prefers nekohtml.
Requires:       nekohtml
Requires:       rhino
Group:          Development/Testing
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Vendor:         JPackage Project
Distribution:   JPackage

%description
HttpUnit emulates the relevant portions of browser behavior, including form
submission, JavaScript, basic http authentication, cookies and automatic page
redirection, and allows Java test code to examine returned pages either as
text, an XML DOM, or containers of forms, tables, and links.
A companion framework, ServletUnit is included in the package.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}

%package manual
Summary:        Manual for %{name}
Group:          Development/Testing

%description manual
Documentation for %{name}

%package demo
Summary:        Demo for %{name}
Group:          Development/Testing
Requires:       %{name} = %{version}-%{release}

%description demo
Demonstrations and samples for %{name}.

# -----------------------------------------------------------------------------

%prep
%setup -q
%patch0 -p0
# remove all binary libs and javadocs
find . -name "*.jar" -exec rm -f {} \;
rm -rf doc/api
ln -s \
  %{javadir}/jaf.jar \
  %{javadir}/javamail/mailapi.jar \
  %{javadir}/junit.jar \
  %{javadir}/jtidy.jar \
  %{javadir}/nekohtml.jar \
  %{javadir}/servlet.jar \
  %{javadir}/js.jar \
  %{javadir}/xerces-j2.jar \
  jars
# fix index.html links to manual
perl -pi -e 's|"doc/|"%{_docdir}/%{name}-manual-%{version}/|g' index.html

# -----------------------------------------------------------------------------

%build
export CLASSPATH=%{javadir}/xml-commons-apis.jar # to nuke javadoc warnings
ant -Dbuild.compiler=modern -Dbuild.sysclasspath=last \
  jar testjar examplesjar javadocs test servlettest

# -----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p  $RPM_BUILD_ROOT%{javadir}
cp -p lib/%{name}.jar $RPM_BUILD_ROOT%{javadir}/%{name}-%{version}.jar

# Jar versioning
(cd $RPM_BUILD_ROOT%{javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# Javadoc
mkdir -p $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{javadocdir}/%{name}-%{version}

# Avoid having api in manual
rm -rf doc/api

# Fix link between manual and javadoc
(cd doc; ln -sf %{javadocdir}/%{name}-%{version} api)

# Demo
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -p examples/* $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -p lib/%{name}-test.jar \
  $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-test-%{version}.jar
cp -p lib/%{name}-examples.jar \
  $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-examples-%{version}.jar

# -----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%files
%defattr(0644,root,root,0755)
%doc index.html
%{javadir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{javadocdir}/%{name}-%{version}

%files manual
%defattr(0644,root,root,0755)
%doc doc/*

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}

# -----------------------------------------------------------------------------

%changelog
* Tue Mar  4 2003 Ville Skytt <ville.skytta at iki.fi> - 1.5.2-1jpp
- Update to 1.5.2.
- Run unit tests during build.

* Wed Dec 18 2002 Ville Skytt <ville.skytta at iki.fi> - 1.5.1-1jpp
- Update to 1.5.1.

* Mon Nov  4 2002 Ville Skytt <ville.skytta at iki.fi> 1.5-1jpp
- Update to 1.5.

* Thu Oct  3 2002 Ville Skytt <ville.skytta at iki.fi> 1.4.6-1jpp
- Update to 1.4.6.

* Fri Sep  6 2002 Ville Skytt <ville.skytta at iki.fi> 1.4.5-0.cvs20020906.1jpp
- Update to 1.4.5 (CVS 2002-09-06, CVS version needed since we have JUnit 3.8).
- Add requirements.
- Add rhino and xerces to build requirements.
- Fix/add Distribution, License, Vendor tags.
- Use sed instead of bash2 extension when symlinking jars during build.
- s/Copyright/License/

* Tue Jul 16 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.4.1-1jpp
- first jpp release
